// override.cpp - LCTextOut

#include <windows.h>
#include "gdi++.h"

// bNAbve[u(255*9=2295)
BYTE ColorTable3x[2296];

// kɎgp郋bNAbve[u
void InitColorTable(void){
	int i;
	// 0`2295܂ł̒l9Ŋ̂LbV
	for(i = 0; i < 2296; i++) ColorTable3x[i] = i / 9;
}

// mȃTCYԂGetTextExtentPoint32iJaneŕ̂Ō݂͕s̗pj
BOOL GetTextExtentPoint32Ex(HDC hdc, LPVOID lpString, int cbString, LPSIZE lpSize, bool IsANSI)
{
	int TextExtra;
	HDC hCanvasDC;
	HFONT hSrcFont, hCanvasFont;
	LOGFONT logCanvasFont;
	SIZE sizeString;

	// DC쐬
	hCanvasDC = CreateCompatibleDC(hdc);
	// `LOGFONT擾
	hSrcFont = (HFONT)SelectObject(hdc, GetStockObject(SYSTEM_FONT));
	GetObject(hSrcFont, sizeof(logCanvasFont), &logCanvasFont);
	SelectObject(hdc, hSrcFont);
	// tHgTCYR{ɂ
	// ɕWA`GCAX𗘗p
	logCanvasFont.lfHeight *= 3;
	logCanvasFont.lfWidth = 0;
	logCanvasFont.lfQuality = ANTIALIASED_QUALITY;
	hCanvasFont = CreateFontIndirect(&logCanvasFont);
	SelectObject(hCanvasDC, hCanvasFont);
	TextExtra = GetTextCharacterExtra(hdc);
	if (TextExtra!=0x8000000) SetTextCharacterExtra(hCanvasDC, TextExtra * 3);
	// `悳镶̑傫擾
	if (IsANSI) {
		GetTextExtentPoint32A(hCanvasDC,(LPCSTR)lpString,cbString, &sizeString);
	} else {
		GetTextExtentPoint32W(hCanvasDC,(LPWSTR)lpString,cbString, &sizeString);
	}
	// 3̔{ɑ
	if ((sizeString.cx % 3) != 0) sizeString.cx += (3 - (sizeString.cx % 3));
	if ((sizeString.cy % 3) != 0) sizeString.cy += (3 - (sizeString.cy % 3));
	// ʂ̃TCY
	sizeString.cx /= 3;
	sizeString.cy /= 3;
	lpSize->cx = sizeString.cx;
	lpSize->cy = sizeString.cy;
	SelectObject(hCanvasDC,  GetStockObject(SYSTEM_FONT));
	DeleteObject(hCanvasFont);
	DeleteDC(hCanvasDC);
	return TRUE;
}

// LCTextOutiДj
BOOL TextOutEx(HDC hdc, int nXStart, int nYStart, LPVOID lpString, int cbString, bool IsANSI)
{
	int x, y, px, py, y1, y2, y3;
	int lCanvasWidth,lCanvasHeight,lDestWidth,lDestHeight;
	int bytesPerScanline;
	int TextExtra;
	HDC hCanvasDC;
	BITMAPINFO bmpDIB;
	HBITMAP hCanvasBitmap, hPrevBitmap;
	HFONT hSrcFont, hCanvasFont;
	LOGFONT logCanvasFont;
	SIZE sizeString;
	LPBYTE lpPixels;

	// DC쐬
	hCanvasDC = CreateCompatibleDC(hdc);
	// `LOGFONT擾
	hSrcFont = (HFONT)SelectObject(hdc, GetStockObject(SYSTEM_FONT));
	GetObject(hSrcFont, sizeof(logCanvasFont), &logCanvasFont);
	SelectObject(hdc, hSrcFont);
	// tHgTCYR{ɂ
	// ɕWA`GCAX𗘗p
	logCanvasFont.lfHeight *= 3;
	logCanvasFont.lfWidth = 0;
	logCanvasFont.lfQuality = ANTIALIASED_QUALITY;
	hCanvasFont = CreateFontIndirect(&logCanvasFont);
	SelectObject(hCanvasDC, hCanvasFont);

	TextExtra = GetTextCharacterExtra(hdc);
	if (TextExtra!=0x8000000) SetTextCharacterExtra(hCanvasDC, TextExtra * 3);
	// `悳镶̑傫擾
	if (IsANSI) {
		GetTextExtentPoint32A(hCanvasDC,(LPCSTR)lpString,cbString, &sizeString);
	} else {
		GetTextExtentPoint32W(hCanvasDC,(LPWSTR)lpString,cbString, &sizeString);
	}
	// 3̔{ɑ
	if ((sizeString.cx % 3) != 0) sizeString.cx += (3-(sizeString.cx % 3));
	if ((sizeString.cy % 3) != 0) sizeString.cy += (3-(sizeString.cy % 3));
	// ʂ̃TCY
	lCanvasWidth = sizeString.cx;
	lCanvasHeight = sizeString.cy;
	// `̃TCY
	lDestWidth = lCanvasWidth / 3;
	lDestHeight = lCanvasHeight / 3;

	bytesPerScanline = (lCanvasWidth << 2);

	// 32bppDIBSection쐬
	bmpDIB.bmiHeader.biSize = sizeof(bmpDIB.bmiHeader);
    bmpDIB.bmiHeader.biWidth = lCanvasWidth;
    bmpDIB.bmiHeader.biHeight = -lCanvasHeight;
    bmpDIB.bmiHeader.biPlanes = 1;
    bmpDIB.bmiHeader.biBitCount = 32;
    bmpDIB.bmiHeader.biCompression = BI_RGB;
    bmpDIB.bmiHeader.biSizeImage = bytesPerScanline * lCanvasHeight;
	hCanvasBitmap = (HBITMAP)CreateDIBSection(hdc, &bmpDIB, DIB_RGB_COLORS,(void **) &lpPixels, NULL, NULL);
	hPrevBitmap = (HBITMAP)SelectObject(hCanvasDC, hCanvasBitmap);

	// wi[h̏ꍇStretchBltŔwi炩ߓ]Ă
	if (GetBkMode(hdc) == TRANSPARENT) {
		SetBkMode(hCanvasDC, TRANSPARENT);
		StretchBlt(hCanvasDC, 0, 0, lCanvasWidth, lCanvasHeight, hdc, nXStart, nYStart, lDestWidth, lDestHeight,SRCCOPY); 
	} else {
		SetBkMode(hCanvasDC, OPAQUE);
		SetBkColor(hCanvasDC, GetBkColor(hdc));
	}
	SetTextColor(hCanvasDC, GetTextColor(hdc));	

	// zmTextOutĂ
	// 1sNZ炵ĕ`悷ƑȂ
	if (IsANSI) {
		TextOutA(hCanvasDC,0,0,(LPCSTR)lpString,cbString);
		TextOutA(hCanvasDC,1,0,(LPCSTR)lpString,cbString);
		TextOutA(hCanvasDC,0,1,(LPCSTR)lpString,cbString);
		TextOutA(hCanvasDC,1,1,(LPCSTR)lpString,cbString);
	} else {
		TextOutW(hCanvasDC,0,0,(LPWSTR)lpString,cbString);
		TextOutW(hCanvasDC,1,0,(LPWSTR)lpString,cbString);
		TextOutW(hCanvasDC,0,1,(LPWSTR)lpString,cbString);
		TextOutW(hCanvasDC,1,1,(LPWSTR)lpString,cbString);
	}

	// 1/3ɏk
	// ̃e[u9x9̃sNZ̕ςvẐɎg
	// Z/Z̎gpĂ݂
	px = 0;
	py = 0;
	y1 = 0;
	y2 = 0;
	y3 = 0;
	for(y = 0; y < lCanvasHeight; y += 3){
		px = 0;
		for(x = 0; x < bytesPerScanline; x += 12){
			y2 = y1 + bytesPerScanline;
			y3 = y2 + bytesPerScanline;
			lpPixels[px + py + 0] = ColorTable3x[lpPixels[0 + x + y1] + lpPixels[4 + x + y1] + lpPixels[ 8 + x + y1] + lpPixels[0 + x + y2] + lpPixels[4 + x + y2] + lpPixels[ 8 + x + y2] + lpPixels[0 + x + y3] + lpPixels[4 + x + y3] + lpPixels[ 8 + x + y3]];
			lpPixels[px + py + 1] = ColorTable3x[lpPixels[1 + x + y1] + lpPixels[5 + x + y1] + lpPixels[ 9 + x + y1] + lpPixels[1 + x + y2] + lpPixels[5 + x + y2] + lpPixels[ 9 + x + y2] + lpPixels[1 + x + y3] + lpPixels[5 + x + y3] + lpPixels[ 9 + x + y3]];
			lpPixels[px + py + 2] = ColorTable3x[lpPixels[2 + x + y1] + lpPixels[6 + x + y1] + lpPixels[10 + x + y1] + lpPixels[2 + x + y2] + lpPixels[6 + x + y2] + lpPixels[10 + x + y2] + lpPixels[2 + x + y3] + lpPixels[6 + x + y3] + lpPixels[10 + x + y3]];
			px += 4;
		}
		py += bytesPerScanline;
		y1 = y3 + bytesPerScanline;
	}

	// ]
	BitBlt(hdc,nXStart,nYStart,lDestWidth,lDestHeight,hCanvasDC,0,0,SRCCOPY);
	
	// n
	SelectObject(hCanvasDC,  GetStockObject(SYSTEM_FONT));
	SelectObject(hCanvasDC, hPrevBitmap);
	DeleteObject(hCanvasFont);
	DeleteObject(hCanvasBitmap);
	DeleteDC(hCanvasDC);
	return TRUE;
}
/*
BOOL WINAPI d_GetTextExtentPoint32A(HDC hdc, LPCSTR lpString, int cbString, LPSIZE lpSize)
{
	return GetTextExtentPoint32Ex(hdc,(LPVOID)lpString,cbString,lpSize,TRUE);
}

BOOL WINAPI d_GetTextExtentPoint32W(HDC hdc, LPCWSTR lpString, int cbString, LPSIZE lpSize)
{
	return GetTextExtentPoint32Ex(hdc,(LPVOID)lpString,cbString,lpSize,FALSE);
}
*/
BOOL WINAPI d_TextOutA(HDC hdc, int nXStart, int nYStart, LPCSTR lpString, int cbString)
{
	// ANSITextOut
	return TextOutEx(hdc, nXStart, nYStart, (LPVOID)lpString, cbString, TRUE);
}

BOOL WINAPI d_TextOutW(HDC hdc, int nXStart, int nYStart, LPCWSTR lpString, int cbString)
{
	// UnicodeTextOut
	return TextOutEx(hdc, nXStart, nYStart, (LPVOID)lpString, cbString, FALSE);
}
