// override.cpp - LCTextOut

#include <windows.h>
#include "user++.h"

// bNAbve[u(255*9=2295)
BYTE ColorTable3x[2296];

// kɎgp郋bNAbve[u
void InitColorTable(void){
	int i;
	// 0`2295܂ł̒l9Ŋ̂LbV
	for(i = 0; i < 2296; i++) ColorTable3x[i] = i / 9;
}

// LCDrawTextExiДj
int DrawTextEx3x(HDC hdc, LPVOID lpchText, int cchText, LPRECT lprc, UINT dwDTFormat, LPDRAWTEXTPARAMS lpDTParams, bool IsANSI)
{
	int x, y, px, py, y1, y2, y3;
	int lCanvasWidth,lCanvasHeight,lDestWidth,lDestHeight;
	int bytesPerScanline;
	int TextExtra;
	HDC hCanvasDC;
	BITMAPINFO bmpDIB;
	HBITMAP hCanvasBitmap, hPrevBitmap;
	HFONT hSrcFont, hCanvasFont;
	LOGFONT logCanvasFont;
	RECT rectString;
	LPBYTE lpPixels;

	// DC쐬
	hCanvasDC = CreateCompatibleDC(hdc);
	// `LOGFONT擾
	hSrcFont = (HFONT)SelectObject(hdc, GetStockObject(SYSTEM_FONT));
	GetObject(hSrcFont, sizeof(logCanvasFont), &logCanvasFont);
	SelectObject(hdc, hSrcFont);
	// tHgTCYR{ɂ
	// ɕWA`GCAX𗘗p
	logCanvasFont.lfHeight *= 3;
	logCanvasFont.lfWidth = 0;
	logCanvasFont.lfQuality = ANTIALIASED_QUALITY;
	hCanvasFont = CreateFontIndirect(&logCanvasFont);
	SelectObject(hCanvasDC, hCanvasFont);

	TextExtra = GetTextCharacterExtra(hdc);
	if (TextExtra!=0x8000000) SetTextCharacterExtra(hCanvasDC, TextExtra * 3);

	if (dwDTFormat==DT_CALCRECT){
		if (IsANSI) { 
			DrawTextExA(hCanvasDC,(TCHAR*)lpchText,cchText,lprc,dwDTFormat,lpDTParams);
		} else {
			DrawTextExW(hCanvasDC,(WCHAR*)lpchText,cchText,lprc,dwDTFormat,lpDTParams);
		}		
		SelectObject(hCanvasDC,  GetStockObject(SYSTEM_FONT));
		DeleteObject(hCanvasFont);
		DeleteDC(hCanvasDC);
		return TRUE;
	}

	rectString.left = 0;
	rectString.top = 0;
	rectString.right = lprc->right - lprc->left;
	rectString.bottom = lprc->bottom - lprc->top;
	// 3̔{ɑ
	if ((rectString.right  % 3) != 0) rectString.right  += (3-(rectString.right  % 3));
	if ((rectString.bottom % 3) != 0) rectString.bottom += (3-(rectString.bottom % 3));
	// ʂ̃TCY
	lCanvasWidth = rectString.right;
	lCanvasHeight = rectString.bottom;
	// `̃TCY
	lDestWidth = lCanvasWidth / 3;
	lDestHeight = lCanvasHeight / 3;

	bytesPerScanline = (lCanvasWidth << 2);

	// 32bppDIBSection쐬
	bmpDIB.bmiHeader.biSize = sizeof(bmpDIB.bmiHeader);
    bmpDIB.bmiHeader.biWidth = lCanvasWidth;
    bmpDIB.bmiHeader.biHeight = -lCanvasHeight;
    bmpDIB.bmiHeader.biPlanes = 1;
    bmpDIB.bmiHeader.biBitCount = 32;
    bmpDIB.bmiHeader.biCompression = BI_RGB;
    bmpDIB.bmiHeader.biSizeImage = bytesPerScanline * lCanvasHeight;
	hCanvasBitmap = (HBITMAP)CreateDIBSection(hdc, &bmpDIB, DIB_RGB_COLORS,(void **) &lpPixels, NULL, NULL);
	hPrevBitmap = (HBITMAP)SelectObject(hCanvasDC, hCanvasBitmap);

	// wi[h̏ꍇStretchBltŔwi炩ߓ]Ă
	if (GetBkMode(hdc) == TRANSPARENT) {
		SetBkMode(hCanvasDC, TRANSPARENT);
		StretchBlt(hCanvasDC, 0, 0, lCanvasWidth, lCanvasHeight, hdc,lprc->left , lprc->top , lDestWidth, lDestHeight,SRCCOPY); 
	} else {
		SetBkMode(hCanvasDC, OPAQUE);
		SetBkColor(hCanvasDC, GetBkColor(hdc));
	}
	SetTextColor(hCanvasDC, GetTextColor(hdc));	

	// zmDrawTextĂ
	// 1sNZ炵ĕ`悷ƑȂ
	if (IsANSI) {
		DrawTextExA(hCanvasDC,(TCHAR*)lpchText,cchText,&rectString,dwDTFormat,lpDTParams);
		rectString.left++;
		DrawTextExA(hCanvasDC,(TCHAR*)lpchText,cchText,&rectString,dwDTFormat,lpDTParams);
		rectString.top++;
		DrawTextExA(hCanvasDC,(TCHAR*)lpchText,cchText,&rectString,dwDTFormat,lpDTParams);
		rectString.top--;
		DrawTextExA(hCanvasDC,(TCHAR*)lpchText,cchText,&rectString,dwDTFormat,lpDTParams);
	} else {
		DrawTextExW(hCanvasDC,(WCHAR*)lpchText,cchText,&rectString,dwDTFormat,lpDTParams);
		rectString.left++;
		DrawTextExW(hCanvasDC,(WCHAR*)lpchText,cchText,&rectString,dwDTFormat,lpDTParams);
		rectString.top++;
		DrawTextExW(hCanvasDC,(WCHAR*)lpchText,cchText,&rectString,dwDTFormat,lpDTParams);
		rectString.top--;
		DrawTextExW(hCanvasDC,(WCHAR*)lpchText,cchText,&rectString,dwDTFormat,lpDTParams);
	}

	// 1/3ɏk
	// ̃e[u9x9̃sNZ̕ςvẐɎg
	// Z/Z̎gpĂ݂
	px = 0;
	py = 0;
	y1 = 0;
	y2 = 0;
	y3 = 0;
	for(y = 0; y < lCanvasHeight; y += 3){
		px = 0;
		for(x = 0; x < bytesPerScanline; x += 12){
			y2 = y1 + bytesPerScanline;
			y3 = y2 + bytesPerScanline;
			lpPixels[px + py + 0] = ColorTable3x[lpPixels[0 + x + y1] + lpPixels[4 + x + y1] + lpPixels[ 8 + x + y1] + lpPixels[0 + x + y2] + lpPixels[4 + x + y2] + lpPixels[ 8 + x + y2] + lpPixels[0 + x + y3] + lpPixels[4 + x + y3] + lpPixels[ 8 + x + y3]];
			lpPixels[px + py + 1] = ColorTable3x[lpPixels[1 + x + y1] + lpPixels[5 + x + y1] + lpPixels[ 9 + x + y1] + lpPixels[1 + x + y2] + lpPixels[5 + x + y2] + lpPixels[ 9 + x + y2] + lpPixels[1 + x + y3] + lpPixels[5 + x + y3] + lpPixels[ 9 + x + y3]];
			lpPixels[px + py + 2] = ColorTable3x[lpPixels[2 + x + y1] + lpPixels[6 + x + y1] + lpPixels[10 + x + y1] + lpPixels[2 + x + y2] + lpPixels[6 + x + y2] + lpPixels[10 + x + y2] + lpPixels[2 + x + y3] + lpPixels[6 + x + y3] + lpPixels[10 + x + y3]];
			px += 4;
		}
		py += bytesPerScanline;
		y1 = y3 + bytesPerScanline;
	}

	// ]
	BitBlt(hdc,lprc->left,lprc->top,lDestWidth,lDestHeight,hCanvasDC,0,0,SRCCOPY);
	
	// n
	SelectObject(hCanvasDC,  GetStockObject(SYSTEM_FONT));
	SelectObject(hCanvasDC, hPrevBitmap);
	DeleteObject(hCanvasFont);
	DeleteObject(hCanvasBitmap);
	DeleteDC(hCanvasDC);
	return TRUE;
}


// LCDrawTextiДj
int DrawText3x(HDC hdc, LPVOID lpString, int nCount, LPRECT lpRect, UINT uFormat, bool IsANSI)
{
	int x, y, px, py, y1, y2, y3;
	int lCanvasWidth,lCanvasHeight,lDestWidth,lDestHeight;
	int bytesPerScanline;
	int TextExtra;
	HDC hCanvasDC;
	BITMAPINFO bmpDIB;
	HBITMAP hCanvasBitmap, hPrevBitmap;
	HFONT hSrcFont, hCanvasFont;
	LOGFONT logCanvasFont;
	RECT rectString;
	LPBYTE lpPixels;

	// DC쐬
	hCanvasDC = CreateCompatibleDC(hdc);
	// `LOGFONT擾
	hSrcFont = (HFONT)SelectObject(hdc, GetStockObject(SYSTEM_FONT));
	GetObject(hSrcFont, sizeof(logCanvasFont), &logCanvasFont);
	SelectObject(hdc, hSrcFont);
	// tHgTCYR{ɂ
	// ɕWA`GCAX𗘗p
	logCanvasFont.lfHeight *= 3;
	logCanvasFont.lfWidth = 0;
	logCanvasFont.lfQuality = ANTIALIASED_QUALITY;
	hCanvasFont = CreateFontIndirect(&logCanvasFont);
	SelectObject(hCanvasDC, hCanvasFont);

	TextExtra = GetTextCharacterExtra(hdc);
	if (TextExtra!=0x8000000) SetTextCharacterExtra(hCanvasDC, TextExtra * 3);

	if (uFormat==DT_CALCRECT){
		if (IsANSI) { 
			DrawTextA(hCanvasDC,(LPCSTR)lpString,nCount,lpRect,uFormat);
		} else {
			DrawTextW(hCanvasDC,(LPCWSTR)lpString,nCount,lpRect,uFormat);
		}		
		SelectObject(hCanvasDC,  GetStockObject(SYSTEM_FONT));
		DeleteObject(hCanvasFont);
		DeleteDC(hCanvasDC);
		return TRUE;
	}
	rectString.left = 0;
	rectString.top = 0;
	rectString.right = lpRect->right - lpRect->left;
	rectString.bottom = lpRect->bottom - lpRect->top;
	// 3̔{ɑ
	if ((rectString.right  % 3) != 0) rectString.right  += (3-(rectString.right  % 3));
	if ((rectString.bottom % 3) != 0) rectString.bottom += (3-(rectString.bottom % 3));
	// ʂ̃TCY
	lCanvasWidth = rectString.right;
	lCanvasHeight = rectString.bottom;
	// `̃TCY
	lDestWidth = lCanvasWidth / 3;
	lDestHeight = lCanvasHeight / 3;

	bytesPerScanline = (lCanvasWidth << 2);

	// 32bppDIBSection쐬
	bmpDIB.bmiHeader.biSize = sizeof(bmpDIB.bmiHeader);
    bmpDIB.bmiHeader.biWidth = lCanvasWidth;
    bmpDIB.bmiHeader.biHeight = -lCanvasHeight;
    bmpDIB.bmiHeader.biPlanes = 1;
    bmpDIB.bmiHeader.biBitCount = 32;
    bmpDIB.bmiHeader.biCompression = BI_RGB;
    bmpDIB.bmiHeader.biSizeImage = bytesPerScanline * lCanvasHeight;
	hCanvasBitmap = (HBITMAP)CreateDIBSection(hdc, &bmpDIB, DIB_RGB_COLORS,(void **) &lpPixels, NULL, NULL);
	hPrevBitmap = (HBITMAP)SelectObject(hCanvasDC, hCanvasBitmap);

	// wi[h̏ꍇStretchBltŔwi炩ߓ]Ă
	if (GetBkMode(hdc) == TRANSPARENT) {
		SetBkMode(hCanvasDC, TRANSPARENT);
		StretchBlt(hCanvasDC, 0, 0, lCanvasWidth, lCanvasHeight, hdc,lpRect->left , lpRect->top , lDestWidth, lDestHeight,SRCCOPY); 
	} else {
		SetBkMode(hCanvasDC, OPAQUE);
		SetBkColor(hCanvasDC, GetBkColor(hdc));
	}
	SetTextColor(hCanvasDC, GetTextColor(hdc));	

	// zmDrawTextĂ
	// 1sNZ炵ĕ`悷ƑȂ
	if (IsANSI) {
		DrawTextA(hCanvasDC,(LPCSTR)lpString,nCount,&rectString,uFormat);
		rectString.left++;
		DrawTextA(hCanvasDC,(LPCSTR)lpString,nCount,&rectString,uFormat);
		rectString.top++;
		DrawTextA(hCanvasDC,(LPCSTR)lpString,nCount,&rectString,uFormat);
		rectString.top--;
		DrawTextA(hCanvasDC,(LPCSTR)lpString,nCount,&rectString,uFormat);
	} else {
		DrawTextW(hCanvasDC,(LPCWSTR)lpString,nCount,&rectString,uFormat);
		rectString.left++;
		DrawTextW(hCanvasDC,(LPCWSTR)lpString,nCount,&rectString,uFormat);
		rectString.top++;
		DrawTextW(hCanvasDC,(LPCWSTR)lpString,nCount,&rectString,uFormat);
		rectString.top--;
		DrawTextW(hCanvasDC,(LPCWSTR)lpString,nCount,&rectString,uFormat);
	}

	// 1/3ɏk
	// ̃e[u9x9̃sNZ̕ςvẐɎg
	// Z/Z̎gpĂ݂
	px = 0;
	py = 0;
	y1 = 0;
	y2 = 0;
	y3 = 0;
	for(y = 0; y < lCanvasHeight; y += 3){
		px = 0;
		for(x = 0; x < bytesPerScanline; x += 12){
			y2 = y1 + bytesPerScanline;
			y3 = y2 + bytesPerScanline;
			lpPixels[px + py + 0] = ColorTable3x[lpPixels[0 + x + y1] + lpPixels[4 + x + y1] + lpPixels[ 8 + x + y1] + lpPixels[0 + x + y2] + lpPixels[4 + x + y2] + lpPixels[ 8 + x + y2] + lpPixels[0 + x + y3] + lpPixels[4 + x + y3] + lpPixels[ 8 + x + y3]];
			lpPixels[px + py + 1] = ColorTable3x[lpPixels[1 + x + y1] + lpPixels[5 + x + y1] + lpPixels[ 9 + x + y1] + lpPixels[1 + x + y2] + lpPixels[5 + x + y2] + lpPixels[ 9 + x + y2] + lpPixels[1 + x + y3] + lpPixels[5 + x + y3] + lpPixels[ 9 + x + y3]];
			lpPixels[px + py + 2] = ColorTable3x[lpPixels[2 + x + y1] + lpPixels[6 + x + y1] + lpPixels[10 + x + y1] + lpPixels[2 + x + y2] + lpPixels[6 + x + y2] + lpPixels[10 + x + y2] + lpPixels[2 + x + y3] + lpPixels[6 + x + y3] + lpPixels[10 + x + y3]];
			px += 4;
		}
		py += bytesPerScanline;
		y1 = y3 + bytesPerScanline;
	}

	// ]
	BitBlt(hdc,lpRect->left,lpRect->top,lDestWidth,lDestHeight,hCanvasDC,0,0,SRCCOPY);
	
	// n
	SelectObject(hCanvasDC,  GetStockObject(SYSTEM_FONT));
	SelectObject(hCanvasDC, hPrevBitmap);
	DeleteObject(hCanvasFont);
	DeleteObject(hCanvasBitmap);
	DeleteDC(hCanvasDC);
	return TRUE;
}

int WINAPI d_DrawTextA(HDC hdc, LPCSTR lpString, int nCount, LPRECT lpRect, UINT uFormat)
{
	// ANSITextOut
	return DrawText3x(hdc, (LPVOID)lpString, nCount, lpRect, uFormat, TRUE);
}

int WINAPI d_DrawTextW(HDC hdc, LPCWSTR lpString, int nCount, LPRECT lpRect, UINT uFormat)
{
	// UnicodeTextOut
	return DrawText3x(hdc, (LPVOID)lpString, nCount, lpRect, uFormat, FALSE);
}

int WINAPI d_DrawTextExA(HDC hdc, LPCSTR lpchText, int cchText, LPRECT lprc, UINT dwDTFormat, LPDRAWTEXTPARAMS lpDTParams)
{
	// ANSITextOut
	return DrawTextEx3x(hdc, (LPVOID)lpchText, cchText, lprc, dwDTFormat, lpDTParams, TRUE);
}

int WINAPI d_DrawTextExW(HDC hdc, LPCWSTR lpchText, int cchText, LPRECT lprc, UINT dwDTFormat, LPDRAWTEXTPARAMS lpDTParams)
{
	// UnicodeTextOut
	return DrawTextEx3x(hdc, (LPVOID)lpchText, cchText, lprc, dwDTFormat, lpDTParams, FALSE);
}
